<?php

namespace RxConnexionBundle\Controller;

use RxConnexionBundle\Form\AccountStaffFrom;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\AccountStaffEntity;

/**
 * @Route("/main/account_staff")
 */
class AccountStaffController extends Controller
{
    /**
     * @Route("", name="account_staff")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Account Staff'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/AccountStaff/index.html.twig', array(
            'title' => 'Manage Account Staff',
            'page_title' => 'Manage Account Staff',
            'javascripts' => array('rxconnexion/admin/js/accountStaff/accountStaff.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="account_staff_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Account Staff Update'), false);
            $hasDetail = $authService->isUserHasAccesses(array('Admin Account Staff Detail'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:AccountStaffEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('account_staff_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }
//                if($hasDetail){
//                    $detailsUrl = $this->generateUrl('account_staff_detail', array(
//                        'account_staff_id' => base64_encode($row['id'])
//
//                    ));
//                    $action .= "<a class='action-button-style' href='$detailsUrl'>Details</a>";
//                }

                $values = array(
                    $row['full_name'],
                    $row['address'],
                    $row['gender'],
                    $row['birthDate'],
                    $row['email'],
                    $row['mobileNo'],
                    $row['phoneNo'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "account_staff_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Account Staff New', 'Admin Account Staff Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $accountStaff = $em->getRepository('RxConnexionBundle:AccountStaffEntity')->find(base64_decode($id));
        if(!$accountStaff) {
            $accountStaff = new AccountStaffEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(AccountStaffFrom::class, $accountStaff, $formOptions);

        if($request->getMethod() === 'POST') {

            $accountStaff_form = $request->get($form->getName());
            $result = $this->processForm($accountStaff_form, $accountStaff, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('account_staff'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('account_staff_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('account_staff_form'), 302);
                }
            } else {
                $form->submit($accountStaff_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Account Staff';

        return $this->render('@RxConnexion/AccountStaff/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/accountStaff/accountStaffs_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($accountStaff_form, $accountStaff, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();
        $errors = $em->getRepository('RxConnexionBundle:AccountStaffEntity')->validate($accountStaff_form);

        if(!count($errors)) {

            switch($accountStaff_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($accountStaff);
                        $em->flush();

                        if(isset($_FILES['form']) && !empty($_FILES['form']['tmp_name']['photo'])) {

                            $baseName = $accountStaff->getId() . '-' . time() . '.' . pathinfo($_FILES['form']['name']['photo'], PATHINFO_EXTENSION);
                            $uploadFile = $accountStaff->getUploadRootDir() . '/' . $baseName;

                            if (move_uploaded_file($_FILES['form']['tmp_name']['photo'], $uploadFile)) {
                                $accountStaff->removePhoto();
                                $accountStaff->setPhotoDescription($_FILES['form']['name']['photo']);
                                $accountStaff->setParsedPhotoDescription($baseName);
                                $em->flush();

                            }
                        }

                        $newAT = new AuditTrailEntity(
                            'Account Staff',
                            $em->getClassMetadata(AccountStaffEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $accountStaff;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Account Staff',
                        $em->getClassMetadata(AccountStaffEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $accountStaff;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {
                        $accountStaff_obj = $em->getRepository('RxConnexionBundle:AccountStaffEntity')->find($accountStaff_form['id']);

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();
                        if(isset($_FILES['form']) && !empty($_FILES['form']['tmp_name']['photo'])) {

                            $baseName = $accountStaff_obj->getId() . '-' . time() . '.' . pathinfo($_FILES['form']['name']['photo'], PATHINFO_EXTENSION);
                            $uploadFile = $accountStaff_obj->getUploadRootDir() . '/' . $baseName;

                            if (move_uploaded_file($_FILES['form']['tmp_name']['photo'], $uploadFile)) {
                                $accountStaff_obj->removePhoto();
                                $accountStaff_obj->setPhotoDescription($_FILES['form']['name']['photo']);
                                $accountStaff_obj->setParsedPhotoDescription($baseName);
                                $em->flush();

                            }
                        }

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Account Staff',
                        $em->getClassMetadata(AccountStaffEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $accountStaff;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($accountStaff);
                        $accountStaff->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route(
     *      "/detail/{account_staff_id}",
     *      name = "account_staff_detail"
     * )
     */
    public function detailAction($accountStaff_id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Account Staff Detail'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();
        $accountStaff = $em->getRepository('RxConnexionBundle:AccountStaffEntity')->find(base64_decode($accountStaff_id));

        $title = 'Manage Account Staff - ' . $accountStaff->getFullName();
        return $this->render('@RxConnexion/AccountStaff/detail.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array(
                'rxconnexion/admin/js/accountStaff/accountStaff_detail.js?v=1.0.0'
            ),
            'account_staff_id' => $accountStaff_id,
            'account_staff' => $accountStaff,
            'tab' => $request->query->get('tab')
        ));
    }

    /**
     * @Route("/autocomplete", name="account_staff_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'account_staffs',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:AccountStaffEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }
}